require "util"
require "mod-gui"
require "story"

local market_products = {

	["pistol"] = { 
	price = { { "coin", 10 } }, 
	offer = { type = "give-item", item = "pistol" },
	},	
	
	["submachine-gun"] = { 
	price = { { "coin", 100 } }, 
	offer = { type = "give-item", item = "submachine-gun" },
	},	
	
	["shotgun"] = { 
	price = { { "coin", 250 } }, 
	offer = { type = "give-item", item = "shotgun" },
	},		
	
	["combat-shotgun"] = { 
	price = { { "coin", 1500 } }, 
	offer = { type = "give-item", item = "combat-shotgun" },
	},	
	
	["rocket-launcher"] = { 
	price = { { "coin", 2000 } }, 
	offer = { type = "give-item", item = "rocket-launcher" },
	},
	
	["flamethrower"] = { 
	price = { { "coin", 1800 } }, 
	offer = { type = "give-item", item = "flamethrower" },
	},		
	
	["land-mine"] = { 
	price = { { "coin", 75 } }, 
	offer = { type = "give-item", item = "land-mine" },
	},		
	
	["firearm-magazine"] = { 
	price = { { "coin", 5 } }, 
	offer = { type = "give-item", item = "firearm-magazine" },
	},		
	
	["piercing-rounds-magazine"] = { 
	price = { { "coin", 15 } }, 
	offer = { type = "give-item", item = "piercing-rounds-magazine" },
	},		
	
	["uranium-rounds-magazine"] = { 
	price = { { "coin", 50 } }, 
	offer = { type = "give-item", item = "uranium-rounds-magazine" },
	},		
	
	["shotgun-shell"] = { 
	price = { { "coin", 10 } }, 
	offer = { type = "give-item", item = "shotgun-shell" },
	},	
	
	["piercing-shotgun-shell"] = { 
	price = { { "coin", 50 } }, 
	offer = { type = "give-item", item = "piercing-shotgun-shell" },
	},	
	
	["cannon-shell"] = { 
	price = { { "coin", 75 } }, 
	offer = { type = "give-item", item = "cannon-shell" },
	},		
	
	["explosive-cannon-shell"] = { 
	price = { { "coin", 100 } }, 
	offer = { type = "give-item", item = "explosive-cannon-shell" },
	},			
	
	["uranium-cannon-shell"] = { 
	price = { { "coin", 250 } }, 
	offer = { type = "give-item", item = "uranium-cannon-shell" },
	},		
	
	["explosive-uranium-cannon-shell"] = { 
	price = { { "coin", 300 } }, 
	offer = { type = "give-item", item = "explosive-uranium-cannon-shell" },
	},		
	
	["rocket"] = { 
	price = { { "coin", 75 } }, 
	offer = { type = "give-item", item = "rocket" },
	},	
	
	["explosive-rocket"] = { 
	price = { { "coin", 100 } }, 
	offer = { type = "give-item", item = "explosive-rocket" },
	},		
	
	["atomic-bomb"] = { 
	price = { { "coin", 40000 } }, 
	offer = { type = "give-item", item = "atomic-bomb" },
	},			
	
	["flamethrower-ammo"] = { 
	price = { { "coin", 65 } }, 
	offer = { type = "give-item", item = "flamethrower-ammo" },
	},		
	
	["grenade"] = { 
	price = { { "coin", 25 } }, 
	offer = { type = "give-item", item = "grenade" },
	},		
	
	["cluster-grenade"] = { 
	price = { { "coin", 125 } }, 
	offer = { type = "give-item", item = "cluster-grenade" },
	},		

	["poison-capsule"] = { 
	price = { { "coin", 75 } }, 
	offer = { type = "give-item", item = "poison-capsule" },
	},	

	["slowdown-capsule"] = { 
	price = { { "coin", 85 } }, 
	offer = { type = "give-item", item = "slowdown-capsule" },
	},		

	["defender-capsule"] = { 
	price = { { "coin", 75 } }, 
	offer = { type = "give-item", item = "defender-capsule" },
	},		

	["distractor-capsule"] = { 
	price = { { "coin", 100 } }, 
	offer = { type = "give-item", item = "distractor-capsule" },
	},	

	["destroyer-capsule"] = { 
	price = { { "coin", 150 } }, 
	offer = { type = "give-item", item = "destroyer-capsule" },
	},			

	["light-armor"] = { 
	price = { { "coin", 250 } }, 
	offer = { type = "give-item", item = "light-armor" },
	},		

	["heavy-armor"] = { 
	price = { { "coin", 500 } }, 
	offer = { type = "give-item", item = "heavy-armor" },
	},	

	["modular-armor"] = { 
	price = { { "coin", 5000 } }, 
	offer = { type = "give-item", item = "modular-armor" },
	},	

	["power-armor"] = { 
	price = { { "coin", 20000 } }, 
	offer = { type = "give-item", item = "power-armor" },
	},	
	
	["power-armor-mk2"] = { 
	price = { { "coin", 65000 } }, 
	offer = { type = "give-item", item = "power-armor-mk2" },
	},		
	
	["solar-panel-equipment"] = { 
	price = { { "coin", 2500 } }, 
	offer = { type = "give-item", item = "solar-panel-equipment" },
	},	
	
	["fusion-reactor-equipment"] = { 
	price = { { "coin", 10000 } }, 
	offer = { type = "give-item", item = "fusion-reactor-equipment" },
	},		
	
	["energy-shield-equipment"] = { 
	price = { { "coin", 3000 } }, 
	offer = { type = "give-item", item = "energy-shield-equipment" },
	},		
	
	["energy-shield-mk2-equipment"] = { 
	price = { { "coin", 15000 } }, 
	offer = { type = "give-item", item = "energy-shield-mk2-equipment" },
	},		
	
	["battery-equipment"] = { 
	price = { { "coin", 1200 } }, 
	offer = { type = "give-item", item = "battery-equipment" },
	},		
	
	["battery-mk2-equipment"] = { 
	price = { { "coin", 20000 } }, 
	offer = { type = "give-item", item = "battery-mk2-equipment" },
	},	
	
	["personal-laser-defense-equipment"] = { 
	price = { { "coin", 30000 } }, 
	offer = { type = "give-item", item = "personal-laser-defense-equipment" },
	},		
	
	["discharge-defense-equipment"] = { 
	price = { { "coin", 5000 } }, 
	offer = { type = "give-item", item = "discharge-defense-equipment" },
	},		
	
	["exoskeleton-equipment"] = { 
	price = { { "coin", 20000 } }, 
	offer = { type = "give-item", item = "exoskeleton-equipment" },
	},		
	
	["personal-roboport-equipment"] = { 
	price = { { "coin", 9000 } }, 
	offer = { type = "give-item", item = "personal-roboport-equipment" },
	},		
	
	["personal-roboport-mk2-equipment"] = { 
	price = { { "coin", 65000 } }, 
	offer = { type = "give-item", item = "personal-roboport-mk2-equipment" },
	},		
	
	["night-vision-equipment"] = { 
	price = { { "coin", 1000 } }, 
	offer = { type = "give-item", item = "night-vision-equipment" },
	},		
	
	["stone-wall"] = { 
	price = { { "coin", 10 } }, 
	offer = { type = "give-item", item = "stone-wall" },
	},	
	
	["gate"] = { 
	price = { { "coin", 25 } }, 
	offer = { type = "give-item", item = "gate" },
	},		
	
	["gun-turret"] = { 
	price = { { "coin", 150 } }, 
	offer = { type = "give-item", item = "gun-turret" },
	},		
	
	["laser-turret"] = { 
	price = { { "coin", 500 } }, 
	offer = { type = "give-item", item = "laser-turret" },
	},		
	
	["flamethrower-turret"] = { 
	price = { { "coin", 450 } }, 
	offer = { type = "give-item", item = "flamethrower-turret" },
	},		
	
	["radar"] = { 
	price = { { "coin", 500 } }, 
	offer = { type = "give-item", item = "radar" },
	},		--]]
	
	------------------------------------

	["iron-axe"] = { 
	price = { { "coin", 100 } }, 
	offer = { type = "give-item", item = "iron-axe" },
	},		
	
	["steel-axe"] = { 
	price = { { "coin", 250 } }, 
	offer = { type = "give-item", item = "steel-axe" },
	},		
	
	["repair-pack"] = { 
	price = { { "coin", 50 } }, 
	offer = { type = "give-item", item = "repair-pack" },
	},		
	
	["boiler"] = { 
	price = { { "coin", 100 } }, 
	offer = { type = "give-item", item = "boiler" },
	},	
	
	["steam-engine"] = { 
	price = { { "coin", 150 } }, 
	offer = { type = "give-item", item = "steam-engine" },
	},		
	
	["steam-turbine"] = { 
	price = { { "coin", 500 } }, 
	offer = { type = "give-item", item = "steam-turbine" },
	},		
	
	["solar-panel"] = { 
	price = { { "coin", 300 } }, 
	offer = { type = "give-item", item = "solar-panel" },
	},	
	
	["accumulator"] = { 
	price = { { "coin", 200 } }, 
	offer = { type = "give-item", item = "accumulator" },
	},		
	
	["nuclear-reactor"] = { 
	price = { { "coin", 10000 } }, 
	offer = { type = "give-item", item = "nuclear-reactor" },
	},	

	["heat-exchanger"] = { 
	price = { { "coin", 250 } }, 
	offer = { type = "give-item", item = "heat-exchanger" },
	},		
	
	["heat-pipe"] = { 
	price = { { "coin", 25 } }, 
	offer = { type = "give-item", item = "heat-pipe" },
	},		
	
	["assembling-machine-3"] = { 
	price = { { "coin", 50 } }, 
	offer = { type = "give-item", item = "assembling-machine-3" },
	},		
	
	-----------------------

	["wooden-chest"] = { 
	price = { { "coin", 25 } }, 
	offer = { type = "give-item", item = "wooden-chest" },
	},		
	
	["iron-chest"] = { 
	price = { { "coin", 100 } }, 
	offer = { type = "give-item", item = "iron-chest" },
	},		
	
	["steel-chest"] = { 
	price = { { "coin", 200 } }, 
	offer = { type = "give-item", item = "steel-chest" },
	},		
	
	["storage-tank"] = { 
	price = { { "coin", 350 } }, 
	offer = { type = "give-item", item = "storage-tank" },
	},		
	
	["small-electric-pole"] = { 
	price = { { "coin", 15 } }, 
	offer = { type = "give-item", item = "small-electric-pole" },
	},	
	
	["medium-electric-pole"] = { 
	price = { { "coin", 50 } }, 
	offer = { type = "give-item", item = "medium-electric-pole" },
	},		
	
	["big-electric-pole"] = { 
	price = { { "coin", 100 } }, 
	offer = { type = "give-item", item = "big-electric-pole" },
	},	
	
	["substation"] = { 
	price = { { "coin", 250 } }, 
	offer = { type = "give-item", item = "substation" },
	},		
	
	["pipe"] = { 
	price = { { "coin", 10 } }, 
	offer = { type = "give-item", item = "pipe" },
	},		
	
	["pipe-to-ground"] = { 
	price = { { "coin", 50 } }, 
	offer = { type = "give-item", item = "pipe-to-ground" },
	},		
	
	["pump"] = { 
	price = { { "coin", 100 } }, 
	offer = { type = "give-item", item = "pump" },
	},	
	
	["car"] = { 
	price = { { "coin", 1000 } }, 
	offer = { type = "give-item", item = "car" },
	},		
	
	["tank"] = { 
	price = { { "coin", 10000 } }, 
	offer = { type = "give-item", item = "tank" },
	},		
	
	["construction-robot"] = { 
	price = { { "coin", 50 } }, 
	offer = { type = "give-item", item = "construction-robot" },
	},		
	
	["roboport"] = { 
	price = { { "coin", 1000 } }, 
	offer = { type = "give-item", item = "roboport" },
	},		
	
	["small-lamp"] = { 
	price = { { "coin", 15 } }, 
	offer = { type = "give-item", item = "small-lamp" },
	},		
	
	["stone-brick"] = { 
	price = { { "coin", 20 } }, 
	offer = { type = "give-item", item = "stone-brick" },
	},		
	
	["concrete"] = { 
	price = { { "coin", 40 } }, 
	offer = { type = "give-item", item = "concrete" },
	},		
	
	["hazard-concrete"] = { 
	price = { { "coin", 40 } }, 
	offer = { type = "give-item", item = "hazard-concrete" },
	},		
	
	["refined-concrete"] = { 
	price = { { "coin", 80 } }, 
	offer = { type = "give-item", item = "refined-concrete" },
	},		
	
	["refined-hazard-concrete"] = { 
	price = { { "coin", 80 } }, 
	offer = { type = "give-item", item = "refined-hazard-concrete" },
	},		
	
	-------------------------

	["raw-wood"] = { 
	price = { { "coin", 10 } }, 
	offer = { type = "give-item", item = "raw-wood" },
	},

	["coal"] = { 
	price = { { "coin", 20 } }, 
	offer = { type = "give-item", item = "coal" },
	},		
	
	["solid-fuel"] = { 
	price = { { "coin", 40 } }, 
	offer = { type = "give-item", item = "solid-fuel" },
	},		
	
	["rocket-fuel"] = { 
	price = { { "coin", 130 } }, 
	offer = { type = "give-item", item = "rocket-fuel" },
	},		
	
	["nuclear-fuel"] = { 
	price = { { "coin", 1000 } }, 
	offer = { type = "give-item", item = "nuclear-fuel" },
	},		
	
	["water-barrel"] = { 
	price = { { "coin", 5 } }, 
	offer = { type = "give-item", item = "water-barrel" },
	},
	
	["crude-oil-barrel"] = { 
	price = { { "coin", 10 } }, 
	offer = { type = "give-item", item = "crude-oil-barrel" },
	},		
	
	["heavy-oil-barrel"] = { 
	price = { { "coin", 15 } }, 
	offer = { type = "give-item", item = "heavy-oil-barrel" },
	},		
	
	["light-oil-barrel"] = { 
	price = { { "coin", 20 } }, 
	offer = { type = "give-item", item = "light-oil-barrel" },
	},	
	
	["raw-fish"] = { 
	price = { { "coin", 15 } }, 
	offer = { type = "give-item", item = "raw-fish" },
	},
	
	--------------
	
	["bullet-damage"] = { 
	price = { { "coin", 250 } }, 
	offer = {
        type = "ammo-damage",
        ammo_category = "bullet",
        modifier = 0.1
      },
	},		
	
	["shotgun-damage"] = { 
	price = { { "coin", 300 } }, 
	offer = {
        type = "ammo-damage",
        ammo_category = "shotgun-shell",
        modifier = 0.1
      },
	},		
	
	["rocket-damage"] = { 
	price = { { "coin", 500 } }, 
	offer = {
        type = "ammo-damage",
        ammo_category = "rocket",
        modifier = 0.1
      },
	},		
	
	["flamethrower-damage"] = { 
	price = { { "coin", 450 } }, 
	offer = {
        type = "ammo-damage",
        ammo_category = "flamethrower",
        modifier = 0.1
      },
	},	
	
	["laser-damage"] = { 
	price = { { "coin", 450 } }, 
	offer = {
        type = "ammo-damage",
        ammo_category = "laser-turret",
        modifier = 0.1
      },
	},		
	
	["grenade-damage"] = { 
	price = { { "coin", 300 } }, 
	offer = {
        type = "ammo-damage",
        ammo_category = "grenade",
        modifier = 0.1
      },
	},		
	
	["cannon-shell-damage"] = { 
	price = { { "coin", 450 } }, 
	offer = {
        type = "ammo-damage",
        ammo_category = "cannon-shell",
        modifier = 0.1
      },
	},		

	["landmine-damage"] = { 
	price = { { "coin", 250 } }, 
	offer = {
        type = "ammo-damage",
        ammo_category = "landmine",
        modifier = 0.1
      },
	},	

	["combat-robot-beam-damage"] = { 
	price = { { "coin", 300 } }, 
	offer = {
        type = "ammo-damage",
        ammo_category = "combat-robot-beam",
        modifier = 0.1
      },
	},		
	
	["combat-robot-laser-damage"] = { 
	price = { { "coin", 350 } }, 
	offer = {
        type = "ammo-damage",
        ammo_category = "combat-robot-laser",
        modifier = 0.1
      },
	},	

	["electric-damage"] = { 
	price = { { "coin", 400 } }, 
	offer = {
        type = "ammo-damage",
        ammo_category = "electric",
        modifier = 0.1
      },
	},

	["capsule-damage"] = { 
	price = { { "coin", 200 } }, 
	offer = {
        type = "ammo-damage",
        ammo_category = "capsule",
        modifier = 0.1
      },
	},
	
	["character-health-bonus"] = { 
	price = { { "coin", 100 } }, 
	offer = {
        type = "character-health-bonus",
        modifier = 25
      },
	},	
	
	["character-running-speed-bonus"] = { 
	price = { { "coin", 100 } }, 
	offer = {
        type = "character-running-speed",
        modifier = 0.1
      },
	},

}

function build_gui(gui)

  local table = gui.add{type = "table", column_count = 3}
  local label = table.add{type = "label", caption = "Extraction : "}
  local progressbar = table.add{type = "progressbar", value = game.forces.enemy.evolution_factor, 3 }
  
end

function random_interval( min, max, boundary_start, boundary_end )

	local num

	repeat
	
		num = math.random( min, max )
	
	until ( num < boundary_start or num > boundary_end )
	
	return num

end

function spawn_enemies()

	local player = game.players[1]
	local surface = game.surfaces[1]
	local evolution = game.forces.enemy.evolution_factor
	local enemies = {
	
		{ name = "small-biter", evolution_start = 0, unit_per_evolution = 0.004 },
		{ name = "small-spitter", evolution_start = 0.1, unit_per_evolution = 0.0045 },
		{ name = "medium-biter", evolution_start = 0.25, unit_per_evolution = 0.005 },
		{ name = "medium-spitter", evolution_start = 0.3, unit_per_evolution = 0.003 },
		{ name = "big-biter", evolution_start = 0.5, unit_per_evolution = 0.01 },
		{ name = "big-spitter", evolution_start = 0.55, unit_per_evolution = 0.01125 },
		{ name = "behemoth-biter", evolution_start = 0.8, unit_per_evolution = 0.01 },
		{ name = "behemoth-spitter", evolution_start = 0.85, unit_per_evolution = 0.015 },
	
	}
	
	local pos = {}
	
	for i = 1, 4 do
	
		local check_pos
	
		repeat

			check_pos = { player.position.x + random_interval( -100, 100, -50, 50 ), player.position.y + random_interval( -100, 100, -50, 50 ) }
		
		until ( surface.can_place_entity{ name = "behemoth-biter", position = check_pos } )
		
		table.insert( pos, check_pos )
	
	end
	
	for k, enemy in pairs( enemies ) do
	
		if enemy.evolution_start <= evolution then
		
			local count = math.floor( ( evolution - enemy.evolution_start ) / enemy.unit_per_evolution ) + 1
		
			for i = 1, count do

				local rand = math.random(1,4)
				local spawn_pos = pos[rand]
			
				local group = surface.create_unit_group{ position = spawn_pos }
			
				local position = surface.find_non_colliding_position( enemy.name, spawn_pos, 0, 2 )

				group.add_member( surface.create_entity{ name = enemy.name, position = position } )
			
				group.set_command
				{
				  type = defines.command.compound,
				  structure_type = defines.compound_command.return_last,
				  commands =
				  {
					{ type = defines.command.go_to_location, destination = player.character.position },
					{ type = defines.command.attack, target = player.character }
				  }
				}
				
				global.units_alive = global.units_alive + 1
			
			end
			
		end
	
	end	

end

function check_units( unit_group )

	if global.units_alive <= 0 then
	
		spawn_enemies()
	
	end

end

function unit_drop( ent )

	local player = game.players[1]

	if ent.name == "small-biter" then
  
		player.insert{ name="coin", count = 10 }
	
	elseif ent.name == "medium-biter" then
	
		player.insert{ name="coin", count = 100 }
		
	elseif ent.name == "big-biter" then
	
		player.insert{ name="coin", count = 1000 }
		
	elseif ent.name == "behemoth-biter" then
	
		player.insert{ name="coin", count = 5000 }

	elseif ent.name == "small-spitter" then
  
		player.insert{ name="coin", count = 20 }
	
	elseif ent.name == "medium-spitter" then
	
		player.insert{ name="coin", count = 200 }
		
	elseif ent.name == "big-spitter" then
	
		player.insert{ name="coin", count = 2000 }
		
	elseif ent.name == "behemoth-spitter" then
	
		player.insert{ name="coin", count = 10000 }
		
	end

end

script.on_init(function()

	global.story = story_init()
	global.units_alive = 0
	
	local market = game.get_entity_by_tag( "market-1" )
	
	for k, modifier in pairs( market_products ) do 
	
		market.add_market_item{ price = modifier.price, offer = modifier.offer }
	
	end
	
  game.map_settings.unit_group.max_group_slowdown_factor = 1
  game.map_settings.unit_group.max_member_speedup_when_behind = 2
  game.map_settings.unit_group.max_member_slowdown_when_ahead = 0.8
  game.map_settings.unit_group.member_disown_distance = 100000
  game.map_settings.unit_group.min_group_radius = 8.0
  game.map_settings.path_finder.use_path_cache = true
  game.map_settings.path_finder.max_steps_worked_per_tick = 300
  game.map_settings.path_finder.short_cache_size = 50
  game.map_settings.path_finder.long_cache_size = 50
  game.map_settings.max_failed_behavior_count = 100000
  
  
  game.map_settings.enemy_evolution.enabled = true
  game.map_settings.enemy_evolution.time_factor = 0
  game.map_settings.enemy_evolution.destroy_factor = 0
  game.map_settings.enemy_evolution.pollution_factor = 0
  

	
end)

script.on_event(defines.events.on_player_created, function(event)

  local player = game.players[event.player_index]
  player.insert{ name = "pistol", count = 1 }
  player.insert{ name = "firearm-magazine", count = 10 }
  player.insert{ name = "coin", count = 1000 }
  
  player.force.chart( player.surface, {{x = -512, y = -512}, {x = 512, y = 512}} )
  
  player.disable_recipe_groups()
  player.disable_recipe_subgroups()
  player.minimap_enabled = false
  player.force.disable_all_prototypes()
  player.force.disable_research()
  
  player.force.recipes["empty-water-barrel"].enabled = true
  player.force.recipes["empty-crude-oil-barrel"].enabled = true
  player.force.recipes["empty-heavy-oil-barrel"].enabled = true
  player.force.recipes["empty-light-oil-barrel"].enabled = true
  
end)

script.on_event(defines.events.on_entity_died, function(event)

  local ent = event.entity
  
  if ent.type == "unit" then
	
		unit_drop( ent )
		
		global.units_alive = global.units_alive - 1
		
		check_units( ent.unit_group )
  
  end
  
end)

story_table =
{
  {
    {
      action =
      function()
        story_show_message_dialog{text = {"begin-1"}}

      end
    },    
	{
      condition = story_elapsed_check(10),
      action =
      function()
		story_show_message_dialog{text = {"begin-2"}}
		spawn_enemies()
      end
    },	
	{
      condition = function()
	    game.forces.enemy.evolution_factor = game.forces.enemy.evolution_factor + ( ( 1 / 1200 ) / 60 )
        set_info({custom_function = build_gui})
		return ( game.forces.enemy.evolution_factor == 1 )
	  end
    },
  }
}

story_init_helpers(story_table)

script.on_event(defines.events.on_tick, function(event)

  story_update(global.story, event, "", on_win)
  
end)

